/*
 * This class is an auto-generated source file for a HAPI
 * HL7 v2.x standard structure class.
 *
 * For more information, visit: http://hl7api.sourceforge.net/
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1 
 * (the "License"); you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.mozilla.org/MPL/ 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the 
 * specific language governing rights and limitations under the License. 
 * 
 * The Original Code is "[file_name]".  Description: 
 * "[one_line_description]" 
 * 
 * The Initial Developer of the Original Code is University Health Network. Copyright (C) 
 * 2012.  All Rights Reserved. 
 * 
 * Contributor(s): ______________________________________. 
 * 
 * Alternatively, the contents of this file may be used under the terms of the 
 * GNU General Public License (the  "GPL"), in which case the provisions of the GPL are 
 * applicable instead of those above.  If you wish to allow use of your version of this 
 * file only under the terms of the GPL and not to allow others to use your version 
 * of this file under the MPL, indicate your decision by deleting  the provisions above 
 * and replace  them with the notice and other provisions required by the GPL License.  
 * If you do not delete the provisions above, a recipient may use your version of 
 * this file under either the MPL or the GPL. 
 * 
 */


package ca.uhn.hl7v2.model.v231.message;

import ca.uhn.hl7v2.model.v231.group.*;
import ca.uhn.hl7v2.model.v231.segment.*;

import ca.uhn.hl7v2.HL7Exception;
import ca.uhn.hl7v2.parser.ModelClassFactory;
import ca.uhn.hl7v2.parser.DefaultModelClassFactory;
import ca.uhn.hl7v2.model.*;


/**
 * <p>Represents a BAR_P06 message structure (see chapter ?). This structure contains the 
 * following elements: </p>
 * <ul>
		                 * <li>1: MSH (MSH - message header segment) <b> </b> </li>
		                 * <li>2: EVN (EVN - event type segment) <b> </b> </li>
		                 * <li>3: BAR_P06_PIDPV1 (a Group object) <b> repeating</b> </li>
 * </ul>
 */
//@SuppressWarnings("unused")
public class BAR_P06 extends AbstractMessage  {

    /**
     * Creates a new BAR_P06 message with DefaultModelClassFactory. 
     */ 
    public BAR_P06() { 
       this(new DefaultModelClassFactory());
    }

    /** 
     * Creates a new BAR_P06 message with custom ModelClassFactory.
     */
    public BAR_P06(ModelClassFactory factory) {
       super(factory);
       init(factory);
    }

    private void init(ModelClassFactory factory) {
       try {
                          this.add(MSH.class, true, false);
	                          this.add(EVN.class, true, false);
	                          this.add(BAR_P06_PIDPV1.class, true, true);
	       } catch(HL7Exception e) {
          log.error("Unexpected error creating BAR_P06 - this is probably a bug in the source code generator.", e);
       }
    }


    /** 
     * Returns "2.3.1"
     */
    public String getVersion() {
       return "2.3.1";
    }




    /**
     * <p>
     * Returns
     * MSH (MSH - message header segment) - creates it if necessary
     * </p>
     * 
     *
     */
    public MSH getMSH() { 
       return getTyped("MSH", MSH.class);
    }





    /**
     * <p>
     * Returns
     * EVN (EVN - event type segment) - creates it if necessary
     * </p>
     * 
     *
     */
    public EVN getEVN() { 
       return getTyped("EVN", EVN.class);
    }





    /**
     * <p>
     * Returns
     * the first repetition of 
     * PIDPV1 (a Group object) - creates it if necessary
     * </p>
     * 
     *
     */
    public BAR_P06_PIDPV1 getPIDPV1() { 
       return getTyped("PIDPV1", BAR_P06_PIDPV1.class);
    }


    /**
     * <p>
     * Returns a specific repetition of
     * PIDPV1 (a Group object) - creates it if necessary
     * </p>
     * 
     *
     * @param rep The repetition index (0-indexed, i.e. the first repetition is at index 0)
     * @throws HL7Exception if the repetition requested is more than one 
     *     greater than the number of existing repetitions.
     */
    public BAR_P06_PIDPV1 getPIDPV1(int rep) { 
       return getTyped("PIDPV1", rep, BAR_P06_PIDPV1.class);
    }

    /** 
     * <p>
     * Returns the number of existing repetitions of PIDPV1 
     * </p>
     * 
     */ 
    public int getPIDPV1Reps() { 
    	return getReps("PIDPV1");
    } 

    /** 
     * <p>
     * Returns a non-modifiable List containing all current existing repetitions of PIDPV1.
     * <p>
     * <p>
     * Note that unlike {@link #getPIDPV1()}, this method will not create any reps
     * if none are already present, so an empty list may be returned.
     * </p>
     * 
     */ 
    public java.util.List<BAR_P06_PIDPV1> getPIDPV1All() throws HL7Exception {
    	return getAllAsList("PIDPV1", BAR_P06_PIDPV1.class);
    } 

    /**
     * <p>
     * Inserts a specific repetition of PIDPV1 (a Group object)
     * </p>
     * 
     *
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public void insertPIDPV1(BAR_P06_PIDPV1 structure, int rep) throws HL7Exception { 
       super.insertRepetition( "PIDPV1", structure, rep);
    }


    /**
     * <p>
     * Inserts a specific repetition of PIDPV1 (a Group object)
     * </p>
     * 
     *
     * @see AbstractGroup#insertRepetition(Structure, int) 
     */
    public BAR_P06_PIDPV1 insertPIDPV1(int rep) throws HL7Exception { 
       return (BAR_P06_PIDPV1)super.insertRepetition("PIDPV1", rep);
    }


    /**
     * <p>
     * Removes a specific repetition of PIDPV1 (a Group object)
     * </p>
     * 
     *
     * @see AbstractGroup#removeRepetition(String, int) 
     */
    public BAR_P06_PIDPV1 removePIDPV1(int rep) throws HL7Exception { 
       return (BAR_P06_PIDPV1)super.removeRepetition("PIDPV1", rep);
    }



}

